# DOMCharacterData Class Reference

The `DOMCharacterData` interface extends DOMNode with a set of attributes and methods for accessing character data in the DOM. More...

Inheritance diagram for DOMCharacterData:

List of all members.

## Public Member Functions

Destructor
virtual | ~DOMCharacterData ()
| Destructor.
Functions introduced in DOM Level 1
virtual const XMLCh * | getData () const =0
| Returns the character data of the node that implements this interface.
virtual XMLSize_t | getLength () const =0
| Returns the number of characters that are available through `data` and the `substringData` method below.
virtual const XMLCh * | substringData (XMLSize_t offset, XMLSize_t count) const =0
| Extracts a range of data from the node.
virtual void | appendData (const XMLCh *arg)=0
| Append the string to the end of the character data of the node.
virtual void | insertData (XMLSize_t offset, const XMLCh *arg)=0
| Insert a string at the specified character offset.
virtual void | deleteData (XMLSize_t offset, XMLSize_t count)=0
| Remove a range of characters from the node.
virtual void | replaceData (XMLSize_t offset, XMLSize_t count, const XMLCh *arg)=0
| Replace the characters starting at the specified character offset with the specified string.
virtual void | setData (const XMLCh *data)=0
| Sets the character data of the node that implements this interface.

## Protected Member Functions

Hidden constructors
| DOMCharacterData ()
| DOMCharacterData (const DOMCharacterData &other)

## Detailed Description

The `DOMCharacterData` interface extends DOMNode with a set of attributes and methods for accessing character data in the DOM.

For clarity this set is defined here rather than on each object that uses these attributes and methods. No DOM objects correspond directly to `DOMCharacterData`, though `DOMText` and others do inherit the interface from it. All `offsets` in this interface start from `0`.

As explained in the DOM spec, text strings in the DOM are represented in UTF-16, i.e. as a sequence of 16-bit units. In the following, the term 16-bit units is used whenever necessary to indicate that indexing on DOMCharacterData is done in 16-bit units.

See also the Document Object Model (DOM) Level 2 Core Specification.

Since:
  DOM Level 1

## Constructor & Destructor Documentation

DOMCharacterData::DOMCharacterData | ( |  | ) | `[protected]`

DOMCharacterData::DOMCharacterData | ( | const DOMCharacterData & | other | ) | `[protected]`

virtual DOMCharacterData::~DOMCharacterData | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual const XMLCh* DOMCharacterData::getData | ( |  | ) | const`[pure virtual]`

Returns the character data of the node that implements this interface.

The DOM implementation may not put arbitrary limits on the amount of data that may be stored in a `DOMCharacterData` node. However, implementation limits may mean that the entirety of a node's data may not fit into a single `XMLCh* String`. In such cases, the user may call `substringData` to retrieve the data in appropriately sized pieces.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

Since:
  DOM Level 1

virtual XMLSize_t DOMCharacterData::getLength | ( |  | ) | const`[pure virtual]`

Returns the number of characters that are available through `data` and the `substringData` method below.

This may have the value zero, i.e., `CharacterData` nodes may be empty.

Since:
  DOM Level 1

virtual const XMLCh* DOMCharacterData::substringData | ( | XMLSize_t | offset,
|  | XMLSize_t | count |
| ) |  |  | const`[pure virtual]`

Extracts a range of data from the node.

Parameters:

  | offset | Start offset of substring to extract.
  | count | The number of characters to extract.

Returns:
  The specified substring. If the sum of `offset` and `count` exceeds the `length`, then all characters to the end of the data are returned.

Exceptions:

  | DOMException | INDEX_SIZE_ERR: Raised if the specified offset is negative or greater than the number of characters in `data`, or if the specified `count` is negative.

Since:
  DOM Level 1

virtual void DOMCharacterData::appendData | ( | const XMLCh * | arg | ) | `[pure virtual]`

Append the string to the end of the character data of the node.

Upon success, `data` provides access to the concatenation of `data` and the `XMLCh* String` specified.

Parameters:

  | arg | The `XMLCh* String` to append.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 1

virtual void DOMCharacterData::insertData | ( | XMLSize_t | offset,
|  | const XMLCh * | arg |
| ) |  |  | `[pure virtual]`

Insert a string at the specified character offset.

Parameters:

  | offset | The character offset at which to insert.
  | arg | The `XMLCh* String` to insert.

Exceptions:

  | DOMException | INDEX_SIZE_ERR: Raised if the specified offset is negative or greater than the number of characters in `data`. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 1

virtual void DOMCharacterData::deleteData | ( | XMLSize_t | offset,
|  | XMLSize_t | count |
| ) |  |  | `[pure virtual]`

Remove a range of characters from the node.

Upon success, `data` and `length` reflect the change.

Parameters:

  | offset | The offset from which to remove characters.
  | count | The number of characters to delete. If the sum of `offset` and `count` exceeds `length` then all characters from `offset` to the end of the data are deleted.

Exceptions:

  | DOMException | INDEX_SIZE_ERR: Raised if the specified offset is negative or greater than the number of characters in `data`, or if the specified `count` is negative. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 1

virtual void DOMCharacterData::replaceData | ( | XMLSize_t | offset,
|  | XMLSize_t | count,
|  | const XMLCh * | arg |
| ) |  |  | `[pure virtual]`

Replace the characters starting at the specified character offset with the specified string.

Parameters:

  | offset | The offset from which to start replacing.
  | count | The number of characters to replace. If the sum of `offset` and `count` exceeds `length` , then all characters to the end of the data are replaced (i.e., the effect is the same as a `remove` method call with the same range, followed by an `append` method invocation).
  | arg | The `XMLCh* String` with which the range must be replaced.

Exceptions:

  | DOMException | INDEX_SIZE_ERR: Raised if the specified offset is negative or greater than the number of characters in `data`, or if the specified `count` is negative. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 1

virtual void DOMCharacterData::setData | ( | const XMLCh * | data | ) | `[pure virtual]`

Sets the character data of the node that implements this interface.

Parameters:

  | data | The `XMLCh* String` to set.

Since:
  DOM Level 1

The documentation for this class was generated from the following file:

- DOMCharacterData.hpp